### org.jfree.layouting.normalizer.generator

# Interface ContentGenerator

All Superinterfaces:
  StatefullComponent

Known Implementing Classes:
  DefaultContentGenerator, EmptyContentGenerator, PrintContentGenerator

`public interface ContentGenerator`
`extends StatefullComponent`

The content generator is the third stage content processor. This part is responsible to process the generated display model and to prepare it for rendering it to the output medium.

In the simplest case, the content generator will be able to pass the display model without any changes. In the more complicated cases, the display model needs to be flattened (as text processors cannot contain paragraphs inside other paragraphs, for instance) before it can be rendered.

  ## Method Summary

  `void`

  `addContent(LayoutContext node, ContentToken contentToken)`

  `void`

  `addPassThroughContent(LayoutContext node, ContentToken token)`

  `void`

  `finishedBlock()`

  `void`

  `finishedDocument()`
    Receives notification, that a new flow has started.

  `void`

  `finishedFlow()`

  `void`

  `finishedInline()`

  `void`

  `finishedMarker()`

  `void`

  `finishedPassThrough()`

  `void`

  `finishedRootInline()`

  `void`

  `finishedTable()`

  `void`

  `finishedTableCaption()`

  `void`

  `finishedTableCell()`

  `void`

  `finishedTableColumn()`

  `void`

  `finishedTableColumnGroup()`

  `void`

  `finishedTableRow()`

  `void`

  `finishedTableSection()`

  `Renderer`

  `getRenderer()`

  `void`

  `handlePageBreak(PageContext pageContext)`
    This event handler is triggered by 'LayoutProcess.pageBreakEncountered()'.

  `void`

  `startedBlock(LayoutContext element)`

  `void`

  `startedDocument(PageContext pageContext)`
    Receives the information, that the document processing has been started.

  `void`

  `startedFlow(LayoutContext element)`

  `void`

  `startedInline(LayoutContext element)`

  `void`

  `startedMarker(LayoutContext element)`

  `void`

  `startedPassThrough(LayoutContext element)`

  `void`

  `startedRootInline(LayoutContext element)`

  `void`

  `startedTable(LayoutContext element)`

  `void`

  `startedTableCaption(LayoutContext context)`

  `void`

  `startedTableCell(LayoutContext element)`

  `void`

  `startedTableColumn(LayoutContext element)`

  `void`

  `startedTableColumnGroup(LayoutContext element)`

  `void`

  `startedTableRow(LayoutContext element)`

  `void`

  `startedTableSection(LayoutContext element)`

  ### Methods inherited from interface org.jfree.layouting.StatefullComponent

  `saveState`

## Method Details

### addContent

    public void addContent(LayoutContext node,
                           ContentToken contentToken)
                throws NormalizationException

### addPassThroughContent

    public void addPassThroughContent(LayoutContext node,
                                      ContentToken token)
                throws NormalizationException

### finishedBlock

    public void finishedBlock()
                throws NormalizationException

### finishedDocument

    public void finishedDocument()
                throws NormalizationException

> Receives notification, that a new flow has started. A new flow is started for each flowing or absolutly positioned element.
> Parameters:

### finishedFlow

    public void finishedFlow()
                throws NormalizationException

### finishedInline

    public void finishedInline()
                throws NormalizationException

### finishedMarker

    public void finishedMarker()
                throws NormalizationException

### finishedPassThrough

    public void finishedPassThrough()
                throws NormalizationException

### finishedRootInline

    public void finishedRootInline()
                throws NormalizationException

### finishedTable

    public void finishedTable()
                throws NormalizationException

### finishedTableCaption

    public void finishedTableCaption()
                throws NormalizationException

### finishedTableCell

    public void finishedTableCell()
                throws NormalizationException

### finishedTableColumn

    public void finishedTableColumn()
                throws NormalizationException

### finishedTableColumnGroup

    public void finishedTableColumnGroup()
                throws NormalizationException

### finishedTableRow

    public void finishedTableRow()
                throws NormalizationException

### finishedTableSection

    public void finishedTableSection()
                throws NormalizationException

### getRenderer

    public Renderer getRenderer()

### handlePageBreak

    public void handlePageBreak(PageContext pageContext)

> This event handler is triggered by 'LayoutProcess.pageBreakEncountered()'.
> Parameters:
>   `pageContext` -

### startedBlock

    public void startedBlock(LayoutContext element)
                throws NormalizationException

### startedDocument

    public void startedDocument(PageContext pageContext)
                throws NormalizationException

> Receives the information, that the document processing has been started. This is fired only once.
> Parameters:
>   `pageContext` - the page context for the default page.

### startedFlow

    public void startedFlow(LayoutContext element)
                throws NormalizationException

### startedInline

    public void startedInline(LayoutContext element)
                throws NormalizationException

### startedMarker

    public void startedMarker(LayoutContext element)
                throws NormalizationException

### startedPassThrough

    public void startedPassThrough(LayoutContext element)
                throws NormalizationException

### startedRootInline

    public void startedRootInline(LayoutContext element)
                throws NormalizationException

### startedTable

    public void startedTable(LayoutContext element)
                throws NormalizationException

### startedTableCaption

    public void startedTableCaption(LayoutContext context)
                throws NormalizationException

### startedTableCell

    public void startedTableCell(LayoutContext element)
                throws NormalizationException

### startedTableColumn

    public void startedTableColumn(LayoutContext element)
                throws NormalizationException

### startedTableColumnGroup

    public void startedTableColumnGroup(LayoutContext element)
                throws NormalizationException

### startedTableRow

    public void startedTableRow(LayoutContext element)
                throws NormalizationException

### startedTableSection

    public void startedTableSection(LayoutContext element)
                throws NormalizationException